VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} FormEnterParameters 
   Caption         =   "Data Ripper:"
   ClientHeight    =   5865
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   11070
   OleObjectBlob   =   "FormEnterParameters.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "FormEnterParameters"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --------------------------------------------------------------------01/06/2009
' DataRipper.swp                   Written by Leonard Kikstra,
'                                   Copyright 2008-2009, Leonard Kikstra
'                                   Downloaded from Lenny's SolidWorks Resources
'                                        at http://www.lennyworks.com/solidworks
' ------------------------------------------------------------------------------
' FormEnterParameters:      Enter parameters and retrieve data
' ------------------------------------------------------------------------------

Dim BaseFileName    As String

' -----------------------------------------------------------------------------
' This function will return text based on occurance of a string "stringToFind"
' within another string "theString", and text before/after defined below.
'
' Locate the occurance of "stringToFind", based on the occur variable.
'   Occur  = 0       Get first occurrance
'            1       Get last occurrance
'
' Return the text (before/after) based on the 'Retrieve' variable.
'   StrRet = 0       Get text before
'            1       Get text after
'            2       If no occurrance found, return blank
' -----------------------------------------------------------------------------
Function NewParseString(theString As String, stringToFind As String, _
                            Occur As Boolean, StrRet As Integer)
  Location = 0
  TempLoc = 0
  PosCount = 1
  While PosCount < Len(theString)
    TempLoc = InStr(PosCount, theString, stringToFind)
    If TempLoc <> 0 Then
      If Occur = 0 Then
        If Location = 0 Then
          Location = TempLoc
        End If
      Else
        Location = TempLoc
      End If
      PosCount = TempLoc + 1
    Else
      PosCount = Len(theString)
    End If
  Wend
  If Location <> 0 Then
    If StrRet = 0 Then
      theString = Mid(theString, 1, Location - 1)
    Else
      theString = Mid(theString, Location + Len(stringToFind))
    End If
  ElseIf StrRet = 2 Then
    theString = ""
  End If
  NewParseString = theString
End Function

Function CUtoMTR(Value1 As Double, DimObj As Integer)
  If MyDimType(DimObj) = swDimensionParamTypeDoubleLinear Then
    Select Case Part.GetUserPreferenceIntegerValue(swUnitsLinear)
         Case swMM
                CUtoMTR = Value1 * 0.001
         Case swCM
                CUtoMTR = Value1 * 0.01
         Case swMETER
                CUtoMTR = Value1 * 1
         Case swINCHES
                CUtoMTR = Value1 * 0.0254
         Case swFEET
                CUtoMTR = Value1 * 0.0254 * 12
         Case Else
                MsgBox "Document units are not recognized"
    End Select
  ElseIf MyDimType(DimObj) = swDimensionParamTypeDoubleAngular Then
    Select Case Part.GetUserPreferenceIntegerValue(swUnitsAngular)
         Case swDEGREES
                CUtoMTR = Value1 * (Pi / 180)
         Case swRADIANS
                CUtoMTR = Value1 * 1
         Case Else
                MsgBox "Document units are not recognized"
    End Select
  End If
End Function

Function MTRtoCU(Value1 As Double, DimObj As Integer)
  If MyDimType(DimObj) = swDimensionParamTypeDoubleLinear Then
    Select Case Part.GetUserPreferenceIntegerValue(swUnitsLinear)
         Case swMM
                MTRtoCU = Value1 / 0.001
         Case swCM
                MTRtoCU = Value1 / 0.01
         Case swMETER
                MTRtoCU = Value1 / 1
         Case swINCHES
                MTRtoCU = Value1 / 0.0254
         Case swFEET
                MTRtoCU = Value1 / (0.0254 * 12)
         Case Else
                MsgBox "Document units are not recognized"
    End Select
  ElseIf MyDimType(DimObj) = swDimensionParamTypeDoubleAngular Then
    Select Case Part.GetUserPreferenceIntegerValue(swUnitsAngular)
         Case swDEGREES
                MTRtoCU = Value1 * (180 / Pi)
         Case swRADIANS
                MTRtoCU = Value1 * 1
         Case Else
                MsgBox "Document units are not recognized"
    End Select
  End If
End Function

Private Sub CommandChart_Click()
  Dim Values        As String
  Dim Separator     As Integer
  Dim NextCol       As Integer
  Dim NextRow       As Integer
  Dim X             As Integer
  Dim ColSpace      As String
  ' - - - - - - - - - - - - - - - - - - - -
  ' This macro will only create one line of data for each button click.
  ' Need to keep previous data.  DO NOT clear existing data from chart.
  ' ListBoxChart.Clear
  ' - - - - - - - - - - - - - - - - - - - -
  ' Create a new row
  ListBoxChart.AddItem 0
  Y = ListBoxChart.ListCount - 1
  
  ' If a dimension is selected in parameter entry area, then
  ' retrieve it's current value and place it in the chart.
  If TextDimension1 <> "" Then _
      ListBoxChart.List(Y, 1 - 1) _
            = Round(MTRtoCU(Part.Parameter(TextDimension1).SystemValue, 1), _
              Len(ComboPrec) - 1)
  If TextDimension2 <> "" Then _
      ListBoxChart.List(Y, 2 - 1) _
            = Round(MTRtoCU(Part.Parameter(TextDimension2).SystemValue, 2), _
              Len(ComboPrec) - 1)
  If TextDimension3 <> "" Then _
      ListBoxChart.List(Y, 3 - 1) _
            = Round(MTRtoCU(Part.Parameter(TextDimension3).SystemValue, 3), _
              Len(ComboPrec) - 1)
  If TextDimension4 <> "" Then _
      ListBoxChart.List(Y, 4 - 1) _
            = Round(MTRtoCU(Part.Parameter(TextDimension4).SystemValue, 4), _
              Len(ComboPrec) - 1)
  If TextDimension5 <> "" Then _
      ListBoxChart.List(Y, 5 - 1) _
            = Round(MTRtoCU(Part.Parameter(TextDimension5).SystemValue, 5), _
              Len(ComboPrec) - 1)
  ' - - - - - - - - - - - - - - - - - - - -
  ' Chart has been updated.
  ' Enable export buttons.
  CommandExportCSV.Enabled = True
  CommandExportExcel.Enabled = True
  ' - - - - - - - - - - - - - - - - - - - -
  ' Display charted data
  ListBoxDisplay.ListIndex = 1
  GoTo NoError
CheckValues:
  MsgBox "Invalid inputs.  Please verify inputs", vbInformation, "DataRipper"

NoError:
End Sub

Private Sub CommandCancel_Click()
  End
End Sub

Private Sub CommandExportCSV_Click()
  ' - - - - - - - - - - - - - - - - - - - -
  ' Setup Export file name
  Dim ExportName        As String
  ExportName = NewParseString(UCase(Part.GetPathName), _
                  ".SLD", 0, 0) + "-DataRip.csv"
  ' - - - - - - - - - - - - - - - - - - - -
  ' Export data
  Open ExportName For Append Access Write Lock Write As #1
  For Row = 0 To ListBoxChart.ListCount - 1             ' For each row
    PrintText = ""                                      ' Clear PrintTest
    For Col = 0 To ListBoxChart.ColumnCount - 1         ' for each column
      PrintText = PrintText + ListBoxChart.List(Row, Col)
      If Col <> ListBoxChart.ColumnCount - 1 Then
        PrintText = PrintText + ","                     ' Add delimit char
      End If
    Next Col                                            ' Next column
    Print #1, LTrim(RTrim(PrintText))                   ' Print to file
  Next Row                                              ' Next row
  Print #1, vbNewLine                                   ' Print blank line
  Close #1
  MsgBox "Charted data has been exported to the file:" & Chr(13) _
          & ExportName, vbInformation, "DataRipper"
  Me.Repaint
End Sub

' -----------------------------------------------------------------------------
' Export to Excel Spreadsheet
' -----------------------------------------------------------------------------
Private Sub CommandExportExcel_Click()
  ' - - - - - - - - - - - - - - - - - - - -
  ' Setup Export file name
  Dim ExportName        As String
  ExportName = NewParseString(UCase(Part.GetPathName), _
                  ".SLD", 0, 0) + "-DataRip.xls"
  ' - - - - - - - - - - - - - - - - - - - -
  ' Launch and attach to the Excel API
  Set XLApp = CreateObject("Excel.Application")
  XLApp.Visible = True
  ' - - - - - - - - - - - - - - - - - - - -
  ' Start new document
  Set wb = XLApp.Workbooks.Add
  ' - - - - - - - - - - - - - - - - - - - -
  ' Set column formats to "Text"
  Prec = "."
  For Col = 1 To Len(ComboPrec) - 1
    Prec = Prec + "0"
  Next Col
  ' - - - - - - - - - - - - - - - - - - - -
  ' Format precision in excel columns
  For Col = 0 To ListBoxChart.ColumnCount - 1       ' for each column
    XLApp.Columns(Chr(Col + 65) & ":" & Chr(Col + 65)).Select
    XLApp.Selection.NumberFormat = Prec             ' Set precision
  Next Col
  ' - - - - - - - - - - - - - - - - - - - -
  ' Prepare to generate BOM in Excel
  Row = 0
  ' - - - - - - - - - - - - - - - - - - - -
  ' For each row
  While (Row < ListBoxChart.ListCount)              ' For each row
    XLCol = 0
    ' - - - - - - - - - - - - - - - - - - - -
    ' Write title row to top of current page of spreadsheet
    For Col = 0 To ListBoxChart.ColumnCount - 1           ' for each column
        ' Write data to specific cell on current page of spreadsheet
        ' Convert listbox coordinates to excel coordinates
        ' NOTE: Listbox cells starts at 0,0 and Excel cells starts at A1
        XLApp.ActiveSheet.Range(Chr(XLCol + 65) & Row + 1).Value _
             = ListBoxChart.List(Row, Col)
        XLCol = XLCol + 1
    Next Col
    Row = Row + 1               ' Next row to read
    XLRow = XLRow + 1           ' Next row to write to Excel
  Wend                          ' Continue loop until all is read
  ' - - - - - - - - - - - - - - - - - - - -
  ' Set each column to AutoFit
  ' to force Autofit of Excel columns, remove apostrophes from next 3 lines
  ' For Col = 0 To ListBoxChart.ListCount - 1
  '   XLApp.Columns(Chr(Col + 65) & ":" & Chr(Col + 65)).EntireColumn.AutoFit
  ' Next Col
  ' - - - - - - - - - - - - - - - - - - - -
  ' Go to cell A1
  XLApp.Range("A1:A1").Select
  ' - - - - - - - - - - - - - - - - - - - -
  ' Save spreadsheet
  XLApp.ActiveWorkbook.SaveAs FileName:=ExportName
  ' - - - - - - - - - - - - - - - - - - - -
  ' Close Excel
  XLApp.Quit
  Set XLApp = Nothing
  MsgBox "Charted data has been exported to the file:" & Chr(13) _
          & ExportName, vbInformation, "DataRipper"
End Sub

Private Sub CommandRemove_Click()
  If ListBoxChart.ListIndex > -1 Then
    ListBoxChart.RemoveItem ListBoxChart.ListIndex
    CommandRemove.Enabled = False
  End If
End Sub

Private Sub ListBoxChart_Click()
  CommandRemove.Enabled = True
End Sub

Private Sub ListBoxDisplay_Click()
  If ListBoxDisplay.ListIndex = 0 Then
    FrameEnter.Visible = True
    FrameDataChart.Visible = False
  Else
    FrameEnter.Visible = False
    FrameDataChart.Visible = True
  End If
End Sub

' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' When these fields are entered (selected), do the following:
'   * Highlight field with salmon color
'   * Set destination of name of selected dimension
'   * Repaint form
' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Private Sub TextDimension1_Enter()
  TextDimension1.BackColor = mySalmon
  TextDimension1.ForeColor = vbBlack
  MyWorkDim = 1
  Me.Repaint
End Sub
Private Sub TextDimension2_Enter()
  TextDimension2.BackColor = mySalmon
  TextDimension2.ForeColor = vbBlack
  MyWorkDim = 2
  Me.Repaint
End Sub
Private Sub TextDimension3_Enter()
  TextDimension3.BackColor = mySalmon
  TextDimension3.ForeColor = vbBlack
  MyWorkDim = 3
  Me.Repaint
End Sub
Private Sub TextDimension4_Enter()
  TextDimension4.BackColor = mySalmon
  TextDimension4.ForeColor = vbBlack
  MyWorkDim = 4
  Me.Repaint
End Sub
Private Sub TextDimension5_Enter()
  TextDimension5.BackColor = mySalmon
  TextDimension5.ForeColor = vbBlack
  MyWorkDim = 5
  Me.Repaint
End Sub

' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' When these fields are exited (after update), do the following:
'   * Reset field to standard colors
'   * Clear destination of name of selected dimension
'   * Repaint form
' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Private Sub TextDimension1_AfterUpdate()
  TextDimension1.BackColor = vbWindowBackground
  TextDimension1.ForeColor = vbWindowText
  MyWorkDim = 0
  Me.Repaint
End Sub
Private Sub TextDimension2_AfterUpdate()
  TextDimension2.BackColor = vbWindowBackground
  TextDimension2.ForeColor = vbWindowText
  MyWorkDim = 0
  Me.Repaint
End Sub
Private Sub TextDimension3_AfterUpdate()
  TextDimension3.BackColor = vbWindowBackground
  TextDimension3.ForeColor = vbWindowText
  MyWorkDim = 0
  Me.Repaint
End Sub
Private Sub TextDimension4_AfterUpdate()
  TextDimension4.BackColor = vbWindowBackground
  TextDimension4.ForeColor = vbWindowText
  MyWorkDim = 0
  Me.Repaint
End Sub
Private Sub TextDimension5_AfterUpdate()
  TextDimension5.BackColor = vbWindowBackground
  TextDimension5.ForeColor = vbWindowText
  MyWorkDim = 0
  Me.Repaint
End Sub

' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' When these fields are exited (after update), do the following:
'   * Reset field to standard colors
'   * Clear destination of name of selected dimension
'   * Repaint form
' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Private Sub TextTitle1_AfterUpdate()
  ListBoxChart.List(0, 0) = TextTitle1.Value
  Me.Repaint
End Sub
Private Sub TextTitle2_AfterUpdate()
  ListBoxChart.List(0, 1) = TextTitle2.Value
  Me.Repaint
End Sub
Private Sub TextTitle3_AfterUpdate()
  ListBoxChart.List(0, 2) = TextTitle3.Value
  Me.Repaint
End Sub
Private Sub TextTitle4_AfterUpdate()
  ListBoxChart.List(0, 3) = TextTitle4.Value
  Me.Repaint
End Sub
Private Sub TextTitle5_AfterUpdate()
  ListBoxChart.List(0, 4) = TextTitle5.Value
  Me.Repaint
End Sub

' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' Initialize user form
' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Private Sub UserForm_Initialize()
  ' - - - - - - - - - - - - - - - - - - - -
  ' Populate precision combobox
  ComboPrec.AddItem "1"
  ComboPrec.AddItem ".1"
  ComboPrec.AddItem ".01"
  ComboPrec.AddItem ".001"
  ComboPrec.AddItem ".0001"
  ComboPrec.AddItem ".00001"
  ComboPrec.AddItem ".000001"
  ComboPrec.AddItem ".0000001"
  ComboPrec.AddItem ".00000001"
  ComboPrec.ListIndex = 3
  ' - - - - - - - - - - - - - - - - - - - -
  ' Setup frame view selection
  ListBoxDisplay.AddItem "Enter Parameters"
  ListBoxDisplay.AddItem "Charted Data"
  ListBoxDisplay.ListIndex = 0
  ' - - - - - - - - - - - - - - - - - - - -
  ' Reposition form elements and resize form
  FrameEnter.Visible = True
  FrameDataChart.Visible = False
  FrameDataChart.Top = 6
  FormEnterParameters.Height = 168
  ' - - - - - - - - - - - - - - - - - - - -
  ' Set form objects to array for faster access
  Set MyDimObj(1) = Me.TextDimension1
  Set MyDimObj(2) = Me.TextDimension2
  Set MyDimObj(3) = Me.TextDimension3
  Set MyDimObj(4) = Me.TextDimension4
  Set MyDimObj(5) = Me.TextDimension5
  ' - - - - - - - - - - - - - - - - - - - -
  ' Handle Pre-Selections.  Selections made before macro was launched
  ' - - - - - - - - - - - - - - - - - - - -
  ' Get selection manager
  Set swSelMgr = Part.SelectionManager
  ' - - - - - - - - - - - - - - - - - - - -
  ' Get number of selections
  Count = swSelMgr.GetSelectedObjectCount2(-1)
  If Count > 0 Then                             ' Is anything selected
    For MyCount = 1 To 5
      ' - - - - - - - - - - - - - - - - - - - -
      ' What type of object was selected
      SelType = swSelMgr.GetSelectedObjectType3(MyCount, -1)
      ' - - - - - - - - - - - - - - - - - - - -
      ' Is it a dimension?
      If swSelMgr.GetSelectedObjectType3(MyCount, -1) = swSelDIMENSIONS Then
        ' - - - - - - - - - - - - - - - - - - - -
        ' For dimensions only
        Set DimSelect = swSelMgr.GetSelectedObject6(MyCount, -1)
        Set swDimen = DimSelect.GetDimension
        If Not DimSelect Is Nothing Then
              MyDimName(MyCount) = swDimen.FullName
              MyDimObj(MyCount) = MyDimName(MyWorkDim)
              MyDimType(MyCount) = swDimen.GetType
        End If
      End If
    Next MyCount
  End If
  CommandRemove.Enabled = False
  ListBoxChart.Clear
  ListBoxChart.AddItem 0
End Sub
